load ../lib/common

__movePackageToRepo() {
	local repo=$1
	local pkgbase=$2
	local arch=$3
	local tarch
	local tarches

	if [[ $arch == any ]]; then
		tarches=(${ARCHES[@]})
	else
		tarches=(${arch})
	fi

	# FIXME: pkgbase might not be part of the package filename
	mv -v "${STAGING}"/${repo}/${pkgbase}-*-*-${arch}${PKGEXT}{,.sig} "${FTP_BASE}/${PKGPOOL}/"
	for tarch in ${tarches[@]}; do
		ln -sv ${FTP_BASE}/${PKGPOOL}/${pkgbase}-*-*-${arch}${PKGEXT} "${FTP_BASE}/${repo}/os/${tarch}/"
		ln -sv ${FTP_BASE}/${PKGPOOL}/${pkgbase}-*-*-${arch}${PKGEXT}.sig "${FTP_BASE}/${repo}/os/${tarch}/"
	done
}

@test "add simple packages" {
	local pkgs=('pkg-simple-a' 'pkg-simple-b')
	local pkgbase
	local arch

	for pkgbase in "${pkgs[@]}"; do
		releasePackage extra "$pkgbase"
		for arch in "${ARCH_BUILD[@]}"; do
			__movePackageToRepo extra ${pkgbase} ${arch}
			db-repo-add extra "${arch}" "${pkgbase}-1-1-${arch}.pkg.tar.xz"
		done
	done

	for pkgbase in "${pkgs[@]}"; do
		checkPackageDB extra "${pkgbase}"
	done
}

@test "add multiple packages" {
	local pkgs=('pkg-simple-a' 'pkg-simple-b')
	local pkgbase
	local arch

	for pkgbase in "${pkgs[@]}"; do
		releasePackage extra "$pkgbase"
	done

	for arch in "${ARCH_BUILD[@]}"; do
		add_pkgs=()
		for pkgbase in "${pkgs[@]}"; do
			__movePackageToRepo extra ${pkgbase} ${arch}
			add_pkgs+=("${pkgbase}-1-1-${arch}.pkg.tar.xz")
		done
		db-repo-add extra "${arch}" "${add_pkgs[@]}"
	done

	for pkgbase in "${pkgs[@]}"; do
		checkPackageDB extra "${pkgbase}"
	done
}

@test "add any packages" {
	local pkgs=('pkg-any-a' 'pkg-any-b')
	local pkgbase
	local arch

	for pkgbase in ${pkgs[@]}; do
		releasePackage extra ${pkgbase}
		__movePackageToRepo extra ${pkgbase} any
		db-repo-add extra any ${pkgbase}-1-1-any.pkg.tar.xz
	done

	for pkgbase in ${pkgs[@]}; do
		checkPackageDB extra ${pkgbase}
	done
}
